#include <iostream>
#include "menu.h"

using namespace std;

Menu::Menu()
{
	cout << "Udvozollek a Math tesztelo alkalmazasban!" << endl;
}

void Menu::run()
{
	int option = 0;
	do
	{
		menuWrite();
		option = getInteger("Valasztott menupont: ");

		switch(option)
		{
			case 1:
				testAdd();
				break;
			case 2:
				testMultiply();
				break;
			case 3:
				testAddResult();
				break;
			case 4:
				testMultiplyResult();
				break;
			case 5:
				testResult();
				break;
		}
	}
	while(option != 0);
}

void Menu::menuWrite() const
{
	cout << endl << endl;
	cout << "--- MENU ---" << endl;
	cout << "Valassz az alabbi opciok kozul!" << endl;
	cout << "\t1 - Ket szam osszeadasa" << endl;
	cout << "\t2 - Ket szam osszeszorzasa" << endl;
	cout << "\t3 - Szam hozzadasa az utolso eredmenyhez" << endl;
	cout << "\t4 - Szam szorzasa az utolso eredmennyel" << endl;
	cout << "\t5 - Utolso eredmeny lekerdezese" << endl;
	cout << "\t0 - Kilepes" << endl;
}

int Menu::getInteger(const string& msg) const
{
	int number;
	bool error;
	do
	{
		cout << msg;
		cin >> number;
		if(cin.fail())
		{
			cin.clear();
			cin.ignore(256, '\n');
			cout << "A megadott ertek nem egesz szam!" << endl;
			error = true;
        }
		else
            error = false;
    }
    while(error);
	return number;
}

void Menu::testAdd()
{
	cout << endl;
	cout << "Ket szam osszeadasa" << endl;
	int a = getInteger("a := ");
	int b = getInteger("b := ");
	cout << "Eredmeny: " << _math.add(a, b) << endl;
}

void Menu::testMultiply()
{
	cout << endl;
	cout << "Ket szam osszeszorzasa" << endl;
	int a = getInteger("a := ");
	int b = getInteger("b := ");
	cout << "Eredmeny: " << _math.multiply(a, b) << endl;
}

void Menu::testAddResult()
{
	cout << endl;
	cout << "Szam hozzadasa az utolso eredmenyhez" << endl;
	int a = getInteger("a := ");
	cout << "Eredmeny: " << _math.addResult(a) << endl;
}

void Menu::testMultiplyResult()
{
	cout << endl;
	cout << "Szam szorzasa az utolso eredmennyel" << endl;
	int a = getInteger("a := ");
	cout << "Eredmeny: " << _math.multiplyResult(a) << endl;
}

void Menu::testResult() const
{
	cout << endl;
	cout << "Utolso eredmeny lekerdezese" << endl;
	cout << "Eredmeny: " << _math.getResult() << endl;
}
